General Int Capability
C Reference » Production Nodes Functionality » Production Node

## Functions

XN_C_API XnStatus XN_C_DECL | xnGetGeneralIntRange (XnNodeHandle hNode, const XnChar *strCap, XnInt32 *pnMin, XnInt32 *pnMax, XnInt32 *pnStep, XnInt32 *pnDefault, XnBool *pbIsAutoSupported)
XN_C_API XnStatus XN_C_DECL | xnGetGeneralIntValue (XnNodeHandle hNode, const XnChar *strCap, XnInt32 *pnValue)
XN_C_API XnStatus XN_C_DECL | xnSetGeneralIntValue (XnNodeHandle hNode, const XnChar *strCap, XnInt32 nValue)
XN_C_API XnStatus XN_C_DECL | xnRegisterToGeneralIntValueChange (XnNodeHandle hNode, const XnChar *strCap, XnStateChangedHandler handler, void *pCookie, XnCallbackHandle *phCallback)
XN_C_API void XN_C_DECL | xnUnregisterFromGeneralIntValueChange (XnNodeHandle hNode, const XnChar *strCap, XnCallbackHandle hCallback)

## Detailed Description

The General Int Capability is a set of method that is used by several capabilities. It allows a general range value to be changed. If supported by the node, the value can also be set to XN_AUTO_CONTROL for automatic adjustment.

The capabilities supporting this interface are:

- Brightness (XN_CAPABILITY_BRIGHTNESS)
- Contrast (XN_CAPABILITY_CONTRAST)
- Hue (XN_CAPABILITY_HUE)
- Saturation (XN_CAPABILITY_SATURATION)
- Sharpness (XN_CAPABILITY_SHARPNESS)
- Gamma (XN_CAPABILITY_GAMMA)
- WhiteBalance (XN_CAPABILITY_COLOR_TEMPERATURE)
- BacklightCompensation (XN_CAPABILITY_BACKLIGHT_COMPENSATION)
- Gain (XN_CAPABILITY_GAIN)
- Pan (XN_CAPABILITY_PAN)
- Tilt (XN_CAPABILITY_TILT)
- Roll (XN_CAPABILITY_ROLL)
- Zoom (XN_CAPABILITY_ZOOM)
- Exposure (XN_CAPABILITY_EXPOSURE)
- Iris (XN_CAPABILITY_IRIS)
- Focus (XN_CAPABILITY_FOCUS)
- Low Light Compensation (XN_CAPABILITY_LOW_LIGHT_COMPENSATION)

## Function Documentation

## xnGetGeneralIntRange()

XN_C_API XnStatus XN_C_DECL xnGetGeneralIntRange | ( | XnNodeHandle | hNode,
|  | const XnChar * | strCap,
|  | XnInt32 * | pnMin,
|  | XnInt32 * | pnMax,
|  | XnInt32 * | pnStep,
|  | XnInt32 * | pnDefault,
|  | XnBool * | pbIsAutoSupported )

Gets the range of this capability values.

Parameters

  hNode | [in] A handle to the instance
  strCap | [in] Name of the capability
  pnMin | [out] Minimum value
  pnMax | [out] Maximum value
  pnStep | [out] Step size
  pnDefault | [out] Default value
  pbIsAutoSupported | [out] TRUE if auto adjustment is supported, FALSE otherwise

## xnGetGeneralIntValue()

XN_C_API XnStatus XN_C_DECL xnGetGeneralIntValue | ( | XnNodeHandle | hNode,
|  | const XnChar * | strCap,
|  | XnInt32 * | pnValue )

Gets the current value of this capability.

Parameters

  hNode | [in] A handle to the instance
  strCap | [in] Name of the capability
  pnValue | [out] Current value

## xnRegisterToGeneralIntValueChange()

XN_C_API XnStatus XN_C_DECL xnRegisterToGeneralIntValueChange | ( | XnNodeHandle | hNode,
|  | const XnChar * | strCap,
|  | XnStateChangedHandler | handler,
|  | void * | pCookie,
|  | XnCallbackHandle * | phCallback )

Registers a callback function to values changes.

Parameters

  hNode | [in] A handle to the instance.
  strCap | [in] Name of the capability
  handler | [in] A pointer to a function that will be called when value changes.
  pCookie | [in] A user cookie that will be passed to the callback function.
  phCallback | [out] Optional. Will be filled with a handle to be passed to xnUnregisterFromGeneralIntValueChange().

## xnSetGeneralIntValue()

XN_C_API XnStatus XN_C_DECL xnSetGeneralIntValue | ( | XnNodeHandle | hNode,
|  | const XnChar * | strCap,
|  | XnInt32 | nValue )

Sets the current value of this capability.

Parameters

  hNode | [in] A handle to the instance
  strCap | [in] Name of the capability
  nValue | [in] Value to set

## xnUnregisterFromGeneralIntValueChange()

XN_C_API void XN_C_DECL xnUnregisterFromGeneralIntValueChange | ( | XnNodeHandle | hNode,
|  | const XnChar * | strCap,
|  | XnCallbackHandle | hCallback )

Unregisters a callback function which was registered using xnRegisterToGeneralIntValueChange().

Parameters

  hNode | [in] A handle to the instance.
  strCap | [in] Name of the capability
  hCallback | [in] The handle to the callback returned from xnRegisterToGeneralIntValueChange().